<?php

namespace App\Filament\Exports;

use App\Models\ProductCharacteristicsMaster;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class ProductCharacteristicsMasterExporter extends Exporter
{
    protected static ?string $model = ProductCharacteristicsMaster::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;
        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.name')
                ->label('PLANT'),
            ExportColumn::make('item.code')
                ->label('ITEM CODE'),
            ExportColumn::make('line.name')
                ->label('LINE NAME'),  //machine.workGroupMaster.name
            ExportColumn::make('machine.workGroupMaster.name')
                ->label('WORK GROUP MASTER'),
            ExportColumn::make('machine.work_center')
                ->label('WORK CENTER'),
            ExportColumn::make('characteristics_type')
                ->label('CHARACTERISTICS TYPE'),
            ExportColumn::make('name')
                ->label('NAME'),
            ExportColumn::make('inspection_type')
                ->label('INSPECTION TYPE'),
            ExportColumn::make('upper')
                ->label('UPPER'),
            ExportColumn::make('lower')
                ->label('LOWER'),
            ExportColumn::make('middle')
                ->label('MIDDLE'),
            ExportColumn::make('created_at')
                ->label('CREATED AT'),
            ExportColumn::make('updated_at')
                ->label('UPDATED AT'),
            ExportColumn::make('created_by')
                ->label('CREATED BY'),
            ExportColumn::make('updated_by')
                ->label('UPDATED BY'),
            ExportColumn::make('deleted_at')
                ->label('DELETED AT')
                ->enabledByDefault(false),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your product characteristics master export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
